# Default rules (merged DOS/UNIX/XENIX version)

# Configuration information
OS=DOS
MACHINE=PC
# OS=unix
# MACHINE=mc68000

# Default suffix macros for files
.IF $(OS)==DOS
E=.exe
O=.obj
S=.asm
A=.lib
F=.for			# Fortran
V=			# no RCS suffix
.ELSE
E=
O=.o
S=.s
A=.a
F=.f
V=,v
.END

.SOURCE		: .
.SOURCE		: RCS
.SUFFIXES	: $E $O .c .e .r .y .yr .ye .l $S $F .p .h
.IF $(OS)!=DOS
.SUFFIXES	:.c,v .e,v .r,v .y,v .yr,v .ye,v .l,v $S,v $F,v .p,v .h,v
.END

# Other standard macros
TMPDIR	:=	$(ROOTDIR)/tmp
.IMPORT .IGNORE: TMPDIR
SHELL		:= $(ROOTDIR)/bin/sh$E
SHELLFLAGS	:= ce
SHELLMETAS	:= |();&<>?*][$$:\\#`'"
GROUPFLAGS	:= e
GROUPSHELL	:= $(SHELL)
GROUPSUFFIX	:= .ksh

# Command names
MAKE	 = $(MAKECMD) $(MFLAGS)		# for System V compatibility
YACC	:= yacc
YACCR	:= yacc -r
YACCE	:= yacc -e
LEX	:= lex
CC	:= cc
AS	:= as
PC	:= pc
RC	:= f77
FC	:= f77
CO	:= co
AR	:= ar
RM	:= rm
.IF $(OS)==DOS
LD	:= "clink"
LEXYY	:= lex_yy
YTAB	:= ytab
.ELSE
LD	 = $(CC)
LEXYY	:= lex.yy
YTAB	:= y.tab
.END

# Command flags and default args
ARFLAGS=uv
CFLAGS=
COFLAGS=-f
LDFLAGS=
LDLIBS=
LFLAGS=
YFLAGS=
RFLAGS=
EFLAGS=
FFLAGS=

# Implicit generation rules
# We don't provide .f, .yr or .ye rules here.  They may be added.
$O$E:;		$(LD) $(LDFLAGS) -o $@ $< $(LDLIBS)
.IF	$(CC)==$(LD)
.l$E:;		$(LEX) $(LFLAGS) $<
		$(CC) $(CLFAGS) $(LDFLAGS) -o $@ $(LEXYY).c $(LDLIBS)
		$(RM) $(LEXYY).c
.y$E:;		$(YACC) $(YFLAGS) $<
		$(CC) $(CFLAGS) (LDFLAGS) -o $@ $(YTAB).c $(LDLIBS)
		$(RM) $(YTAB).c
.c$E:;		$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LDLIBS)
$S$E:;		$(CC) $(LDFLAGS) -o $@ $< $(LDLIBS)
.ELSE
.l$E:;		$(LEX) $(LFLAGS) $<
		$(CC) $(CFLAGS) -c $(LEXYY).c
		$(LD) $(LDFLAGS) -o $@ $(LEXYY)$O $(LDLIBS)
		$(RM) $(LEXYY){.c $O}
.y$E:;		$(YACC) $(YFLAGS) $<
		$(CC) $(CFLAGS) -c $(YTAB).c
		$(LD) $(LDFLAGS) -o $@ $(YTAB)$O $(LDLIBS)
		$(RM) $(YTAB){.c $O}
.c$E:;		$(CC) $(CFLAGS) -c $<
		$(LD) $(LDFLAGS) -o $@ $*$O $(LDLIBS)
$S$E:;		$(AS) $<
		$(LD) $(LDFLAGS) -o $@ $*$O $(LDLIBS)
		$(RM) $*$O
.END
$S$O:;		$(AS) $<
.c$O:;		$(CC) $(CFLAGS) -c $<
.p$O:;		$(PC) $(PFLAGS) -c $<
$F$O .r$O .e$O:; $(FC) $(RFLAGS) $(EFLAGS) $(FFLAGS) -c $<
.y$O:;		$(YACC) $(YFLAGS) -o $*.c $<
		$(CC) $(CFLAGS) -c $*.c
.l$O:;		$(LEX) $(LFLAGS) -o $*.c $<
		$(CC) $(CFLAGS) -c $*.c
.y.c:;		$(YACC) $(YFLAGS) -o $@ $<
.l.c:;		$(LEX) $(LFLAGS) -o $@ $<

# RCS support (where ,v suffixes exist)
.IF $(OS)!=DOS
.c,v.c .h,v.h .l,v.l .y,v.y $S,v$S $F,v$F:; $(CO) $(COFLAGS) $<
.ELSE
.RCSPROLOG:;	$(CO) $(COFLAGS) $<
.END

# Archive support (template for explicit rules)
# lib$A .LIBRARY: mem1$O mem2$O; $(AR) $(ARFLAGS) $@ $<

# Local startup.mk file
.INCLUDE .IGNORE:	startup.mk
